/*
 * (c) Copyright 2005 Hewlett-Packard Development Company, LP
 * [See end of file]
 */

package com.hp.hpl.jena.ontology.tidy.impl;


/**
 * @author Jeremy J. Carroll
 *
 */
abstract public class DomainRangeProblem extends SingleTripleProblem implements
        WantedGiven {

    private int wanted, given;
    public DomainRangeProblem(String msg){
        super(msg);
    }
    /* (non-Javadoc)
     * @see com.hp.hpl.jena.ontology.tidy.impl.WantedGiven#getWanted()
     */
    public int getWanted() {
        return wanted;
    }

    /* (non-Javadoc)
     * @see com.hp.hpl.jena.ontology.tidy.impl.WantedGiven#getGiven()
     */
    public int getGiven() {
        return given;
    }
    
    public void setWanted(int w){
        wanted = w;
    }
    public void setGiven(int g){
        given = g;
    }
    
    
    public String toString() {
        return super.toString().replaceAll("%g",(String)CategorySetNames.names[given][1])
.replaceAll("%w",(String)CategorySetNames.names[wanted][1]);
    }


}


/*
 *  (c) Copyright 2005 Hewlett-Packard Development Company, LP
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
